// The clock object we are going to create.
// You could create multiple clocks for multiple text objects - one for the time one for the date for instance.
var myClock, myDate, previousVolume, timeout;

CF.userMain = function() {

	myClock = new DateTimeDriver("s2", "hh:mm tt");
	// If you want the clock to start instantly, uncomment this next line:
	myClock.start();

	myDate = new DateTimeDriver("s3", "dddd, MMMM dd, yyyy", 60000); // Update every minute.
	myDate.start();
	// Watch for changes to volume
	CF.watch(CF.DevicePropertyChangeEvent, CF.SoundOutputVolumeProperty, function onPropertyChange(property, value) {
		// Ensure volume change is detected
		if (property == CF.SoundOutputVolumeProperty) {
			// Log the volume level for debugging
			CF.log("New Volume: " + value);

			// Volume will continue to report 1 whilst volume up is pressed and iOS device volume is already at full
			// So add checks for that (same for when volume is at lowest and vol down button is pressed)

			// NOTE: CURRENTLY THE SOUND LEVEL IS NOT REPORTED WHEN VOLUME BUTTON IS PRESSED IF THE VOLUME LEVEL DOESNT CHANGE!
			// Example: current volume = full, press volume up button will not trigger the event.
			// TODO - change iViewer to allow this.
			if (value > previousVolume || value == 1) {
				// vol up pressed
				CF.setJoin("s4", "Volume Up Pressed, volume = " + value);
			} else {
				// vol down pressed
				CF.setJoin("s4", "Volume Down Pressed, volume = " + value);
			}

			// Set the screen brightness to match the volume as an example
			CF.setDeviceProperty(CF.ScreenBrightnessProperty, value);

			// Clear message one second later
			clearTimeout(timeout);
			timeout = setTimeout(function(){CF.setJoin("s4");}, 2000);
			// Store volume for comparion on next volume change
			previousVolume = value;
		}
	});
}